Scriptname IMP_Elementalist extends activemagiceffect  

Actor target
int prevSpellType

Globalvariable property IMP_GLO_ElementalistValue auto

Keyword property MagicDamageFire auto
Keyword property MagicDamageFrost auto
Keyword property MagicDamageShock auto
Keyword property MagicShout auto
Keyword property MagicDamageEarth auto
Keyword property MagicDamageWater auto
Keyword property MagicDamageWind auto

;------------------------------------------------------------------------------------------------------------------

Event OnEffectStart(Actor akTarget, Actor akCaster)
	target =  akTarget

	prevSpellType = 0  ;0 = nothing, 1=fire, 2=frost, 3=shock, 4=earth, 5=water, 6=wind

	IMP_GLO_ElementalistValue.Value = 0
EndEvent

;------------------------------------------------------------------------------------------------------------------

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	IMP_GLO_ElementalistValue.Value = 0

EndEvent

;------------------------------------------------------------------------------------------------------------------

Event OnSpellCast(Form akSpell)
	If (akSpell as Spell)
		Spell curSpell = akSpell as Spell
		If !(curSpell.HasKeyword(MagicShout))
			If (curSpell.HasKeyword(MagicDamageFire)) && (prevSpellType != 1)
				If (prevSpellType != 0) ;make sure this isn't the first time casting a spell
					If (IMP_GLO_ElementalistValue.Value < 6) ;Don't increase value if cap has been reached
						IMP_GLO_ElementalistValue.Value += 1
					;	debug.notification("ELEMENTALIST: " + IMP_GLO_ElementalistValue.Value)
					Endif
				Endif
				prevSpellType = 1
				registerForSingleUpdate(10)
			Elseif (curSpell.HasKeyword(MagicDamageFrost)) && (prevSpellType != 2)
				If (prevSpellType != 0) 
					If (IMP_GLO_ElementalistValue.Value < 6) ;Don't increase value if cap has been reached
						IMP_GLO_ElementalistValue.Value += 1
					;	debug.notification("ELEMENTALIST: " + IMP_GLO_ElementalistValue.Value)
					Endif
				Endif
				prevSpellType = 2
				registerForSingleUpdate(10)
			Elseif (curSpell.HasKeyword(MagicDamageShock)) && (prevSpellType != 3)
				If (prevSpellType != 0) 
					If (IMP_GLO_ElementalistValue.Value < 6) ;Don't increase value if cap has been reached
						IMP_GLO_ElementalistValue.Value += 1
					;	debug.notification("ELEMENTALIST: " + IMP_GLO_ElementalistValue.Value)
					Endif
				Endif
				prevSpellType = 3
				registerForSingleUpdate(10)
			Elseif (curSpell.HasKeyword(MagicDamageEarth)) && (prevSpellType != 4)
				If (prevSpellType != 0) 
					If (IMP_GLO_ElementalistValue.Value < 6) ;Don't increase value if cap has been reached
						IMP_GLO_ElementalistValue.Value += 1
					;	debug.notification("ELEMENTALIST: " + IMP_GLO_ElementalistValue.Value)
					Endif
				Endif
				prevSpellType = 4
				registerForSingleUpdate(10)		
			Elseif (curSpell.HasKeyword(MagicDamageWater)) && (prevSpellType != 5)
				If (prevSpellType != 0) 
					If (IMP_GLO_ElementalistValue.Value < 6) ;Don't increase value if cap has been reached
						IMP_GLO_ElementalistValue.Value += 1
					;	debug.notification("ELEMENTALIST: " + IMP_GLO_ElementalistValue.Value)
					Endif
				Endif
				prevSpellType = 5
				registerForSingleUpdate(10)
			Elseif (curSpell.HasKeyword(MagicDamageWind)) && (prevSpellType != 6)
				If (prevSpellType != 0) 
					If (IMP_GLO_ElementalistValue.Value < 6) ;Don't increase value if cap has been reached
						IMP_GLO_ElementalistValue.Value += 1
					;	debug.notification("ELEMENTALIST: " + IMP_GLO_ElementalistValue.Value)
					Endif
				Endif
				prevSpellType = 6
				registerForSingleUpdate(10)
			Endif
		Endif
	Endif

EndEvent

;------------------------------------------------------------------------------------------------------------------

Event OnUpdate()
	prevSpellType = 0  ;more than 5 seconds has passed, so reset the bonus
	IMP_GLO_ElementalistValue.Value = 0
;	debug.notification("ELEMENTALIST: " + IMP_GLO_ElementalistValue.Value)
EndEvent
